/* Autogenerated file. Do not edit manually. */
/* tslint:disable */
/* eslint-disable */

import {
  ethers,
  EventFilter,
  Signer,
  BigNumber,
  BigNumberish,
  PopulatedTransaction,
  BaseContract,
  ContractTransaction,
  Overrides,
  CallOverrides,
} from "ethers";
import { BytesLike } from "@ethersproject/bytes";
import { Listener, Provider } from "@ethersproject/providers";
import { FunctionFragment, EventFragment, Result } from "@ethersproject/abi";
import type { TypedEventFilter, TypedEvent, TypedListener } from "./common";

interface MintingInterface extends ethers.utils.Interface {
  functions: {
    "APR_10()": FunctionFragment;
    "APR_12_5()": FunctionFragment;
    "APR_15()": FunctionFragment;
    "APR_5()": FunctionFragment;
    "APR_7_5()": FunctionFragment;
    "DENOMINATOR()": FunctionFragment;
    "MAX_STAKE_AMOUNT()": FunctionFragment;
    "MAX_STAKE_PERIOD()": FunctionFragment;
    "MIN_REWARDS_DURATION()": FunctionFragment;
    "MIN_STAKE_AMOUNT()": FunctionFragment;
    "MIN_STAKE_PERIOD()": FunctionFragment;
    "YEAR()": FunctionFragment;
    "balanceOf(address)": FunctionFragment;
    "emergencyWithdrawRewards(uint256,uint256,address)": FunctionFragment;
    "factory()": FunctionFragment;
    "getAPRForDuration(uint256)": FunctionFragment;
    "getHoldersLength()": FunctionFragment;
    "getHoldersSlice(uint256,uint256)": FunctionFragment;
    "getRewardsAvailable()": FunctionFragment;
    "getStakeMaxReserves(uint256)": FunctionFragment;
    "getUserInactiveStakesLength(address)": FunctionFragment;
    "getUserInactiveStakesSlice(address,uint256,uint256)": FunctionFragment;
    "getUserStakeIds(address)": FunctionFragment;
    "getUserStakeIdsLength(address)": FunctionFragment;
    "getUserStakesIdsSlice(address,uint256,uint256)": FunctionFragment;
    "globalId()": FunctionFragment;
    "initialize(address,address,address,uint256,uint256,address)": FunctionFragment;
    "initialized()": FunctionFragment;
    "maxPotentialDebtA()": FunctionFragment;
    "maxPotentialDebtB()": FunctionFragment;
    "numOfActiveStakes()": FunctionFragment;
    "owner()": FunctionFragment;
    "pair()": FunctionFragment;
    "paused()": FunctionFragment;
    "renounceOwnership()": FunctionFragment;
    "rewardTokenA()": FunctionFragment;
    "rewardTokenB()": FunctionFragment;
    "router()": FunctionFragment;
    "setPaused(bool)": FunctionFragment;
    "stake(uint256,uint256)": FunctionFragment;
    "stakes(uint256)": FunctionFragment;
    "tokenAFactor()": FunctionFragment;
    "tokenBFactor()": FunctionFragment;
    "transferOwnership(address)": FunctionFragment;
    "userBalances(address)": FunctionFragment;
    "userInactiveStakes(address,uint256)": FunctionFragment;
    "withdraw(uint256)": FunctionFragment;
  };

  encodeFunctionData(functionFragment: "APR_10", values?: undefined): string;
  encodeFunctionData(functionFragment: "APR_12_5", values?: undefined): string;
  encodeFunctionData(functionFragment: "APR_15", values?: undefined): string;
  encodeFunctionData(functionFragment: "APR_5", values?: undefined): string;
  encodeFunctionData(functionFragment: "APR_7_5", values?: undefined): string;
  encodeFunctionData(
    functionFragment: "DENOMINATOR",
    values?: undefined
  ): string;
  encodeFunctionData(
    functionFragment: "MAX_STAKE_AMOUNT",
    values?: undefined
  ): string;
  encodeFunctionData(
    functionFragment: "MAX_STAKE_PERIOD",
    values?: undefined
  ): string;
  encodeFunctionData(
    functionFragment: "MIN_REWARDS_DURATION",
    values?: undefined
  ): string;
  encodeFunctionData(
    functionFragment: "MIN_STAKE_AMOUNT",
    values?: undefined
  ): string;
  encodeFunctionData(
    functionFragment: "MIN_STAKE_PERIOD",
    values?: undefined
  ): string;
  encodeFunctionData(functionFragment: "YEAR", values?: undefined): string;
  encodeFunctionData(functionFragment: "balanceOf", values: [string]): string;
  encodeFunctionData(
    functionFragment: "emergencyWithdrawRewards",
    values: [BigNumberish, BigNumberish, string]
  ): string;
  encodeFunctionData(functionFragment: "factory", values?: undefined): string;
  encodeFunctionData(
    functionFragment: "getAPRForDuration",
    values: [BigNumberish]
  ): string;
  encodeFunctionData(
    functionFragment: "getHoldersLength",
    values?: undefined
  ): string;
  encodeFunctionData(
    functionFragment: "getHoldersSlice",
    values: [BigNumberish, BigNumberish]
  ): string;
  encodeFunctionData(
    functionFragment: "getRewardsAvailable",
    values?: undefined
  ): string;
  encodeFunctionData(
    functionFragment: "getStakeMaxReserves",
    values: [BigNumberish]
  ): string;
  encodeFunctionData(
    functionFragment: "getUserInactiveStakesLength",
    values: [string]
  ): string;
  encodeFunctionData(
    functionFragment: "getUserInactiveStakesSlice",
    values: [string, BigNumberish, BigNumberish]
  ): string;
  encodeFunctionData(
    functionFragment: "getUserStakeIds",
    values: [string]
  ): string;
  encodeFunctionData(
    functionFragment: "getUserStakeIdsLength",
    values: [string]
  ): string;
  encodeFunctionData(
    functionFragment: "getUserStakesIdsSlice",
    values: [string, BigNumberish, BigNumberish]
  ): string;
  encodeFunctionData(functionFragment: "globalId", values?: undefined): string;
  encodeFunctionData(
    functionFragment: "initialize",
    values: [string, string, string, BigNumberish, BigNumberish, string]
  ): string;
  encodeFunctionData(
    functionFragment: "initialized",
    values?: undefined
  ): string;
  encodeFunctionData(
    functionFragment: "maxPotentialDebtA",
    values?: undefined
  ): string;
  encodeFunctionData(
    functionFragment: "maxPotentialDebtB",
    values?: undefined
  ): string;
  encodeFunctionData(
    functionFragment: "numOfActiveStakes",
    values?: undefined
  ): string;
  encodeFunctionData(functionFragment: "owner", values?: undefined): string;
  encodeFunctionData(functionFragment: "pair", values?: undefined): string;
  encodeFunctionData(functionFragment: "paused", values?: undefined): string;
  encodeFunctionData(
    functionFragment: "renounceOwnership",
    values?: undefined
  ): string;
  encodeFunctionData(
    functionFragment: "rewardTokenA",
    values?: undefined
  ): string;
  encodeFunctionData(
    functionFragment: "rewardTokenB",
    values?: undefined
  ): string;
  encodeFunctionData(functionFragment: "router", values?: undefined): string;
  encodeFunctionData(functionFragment: "setPaused", values: [boolean]): string;
  encodeFunctionData(
    functionFragment: "stake",
    values: [BigNumberish, BigNumberish]
  ): string;
  encodeFunctionData(
    functionFragment: "stakes",
    values: [BigNumberish]
  ): string;
  encodeFunctionData(
    functionFragment: "tokenAFactor",
    values?: undefined
  ): string;
  encodeFunctionData(
    functionFragment: "tokenBFactor",
    values?: undefined
  ): string;
  encodeFunctionData(
    functionFragment: "transferOwnership",
    values: [string]
  ): string;
  encodeFunctionData(
    functionFragment: "userBalances",
    values: [string]
  ): string;
  encodeFunctionData(
    functionFragment: "userInactiveStakes",
    values: [string, BigNumberish]
  ): string;
  encodeFunctionData(
    functionFragment: "withdraw",
    values: [BigNumberish]
  ): string;

  decodeFunctionResult(functionFragment: "APR_10", data: BytesLike): Result;
  decodeFunctionResult(functionFragment: "APR_12_5", data: BytesLike): Result;
  decodeFunctionResult(functionFragment: "APR_15", data: BytesLike): Result;
  decodeFunctionResult(functionFragment: "APR_5", data: BytesLike): Result;
  decodeFunctionResult(functionFragment: "APR_7_5", data: BytesLike): Result;
  decodeFunctionResult(
    functionFragment: "DENOMINATOR",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "MAX_STAKE_AMOUNT",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "MAX_STAKE_PERIOD",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "MIN_REWARDS_DURATION",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "MIN_STAKE_AMOUNT",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "MIN_STAKE_PERIOD",
    data: BytesLike
  ): Result;
  decodeFunctionResult(functionFragment: "YEAR", data: BytesLike): Result;
  decodeFunctionResult(functionFragment: "balanceOf", data: BytesLike): Result;
  decodeFunctionResult(
    functionFragment: "emergencyWithdrawRewards",
    data: BytesLike
  ): Result;
  decodeFunctionResult(functionFragment: "factory", data: BytesLike): Result;
  decodeFunctionResult(
    functionFragment: "getAPRForDuration",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "getHoldersLength",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "getHoldersSlice",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "getRewardsAvailable",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "getStakeMaxReserves",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "getUserInactiveStakesLength",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "getUserInactiveStakesSlice",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "getUserStakeIds",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "getUserStakeIdsLength",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "getUserStakesIdsSlice",
    data: BytesLike
  ): Result;
  decodeFunctionResult(functionFragment: "globalId", data: BytesLike): Result;
  decodeFunctionResult(functionFragment: "initialize", data: BytesLike): Result;
  decodeFunctionResult(
    functionFragment: "initialized",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "maxPotentialDebtA",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "maxPotentialDebtB",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "numOfActiveStakes",
    data: BytesLike
  ): Result;
  decodeFunctionResult(functionFragment: "owner", data: BytesLike): Result;
  decodeFunctionResult(functionFragment: "pair", data: BytesLike): Result;
  decodeFunctionResult(functionFragment: "paused", data: BytesLike): Result;
  decodeFunctionResult(
    functionFragment: "renounceOwnership",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "rewardTokenA",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "rewardTokenB",
    data: BytesLike
  ): Result;
  decodeFunctionResult(functionFragment: "router", data: BytesLike): Result;
  decodeFunctionResult(functionFragment: "setPaused", data: BytesLike): Result;
  decodeFunctionResult(functionFragment: "stake", data: BytesLike): Result;
  decodeFunctionResult(functionFragment: "stakes", data: BytesLike): Result;
  decodeFunctionResult(
    functionFragment: "tokenAFactor",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "tokenBFactor",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "transferOwnership",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "userBalances",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "userInactiveStakes",
    data: BytesLike
  ): Result;
  decodeFunctionResult(functionFragment: "withdraw", data: BytesLike): Result;

  events: {
    "OwnershipTransferred(address,address)": EventFragment;
    "Paused(address)": EventFragment;
    "RewardAdded(uint256)": EventFragment;
    "RewardPaid(address,uint256,uint256)": EventFragment;
    "RewardsDurationUpdated(uint256)": EventFragment;
    "Staked(address,uint256,uint256)": EventFragment;
    "Unpaused(address)": EventFragment;
    "Withdrawn(address,uint256,uint256)": EventFragment;
  };

  getEvent(nameOrSignatureOrTopic: "OwnershipTransferred"): EventFragment;
  getEvent(nameOrSignatureOrTopic: "Paused"): EventFragment;
  getEvent(nameOrSignatureOrTopic: "RewardAdded"): EventFragment;
  getEvent(nameOrSignatureOrTopic: "RewardPaid"): EventFragment;
  getEvent(nameOrSignatureOrTopic: "RewardsDurationUpdated"): EventFragment;
  getEvent(nameOrSignatureOrTopic: "Staked"): EventFragment;
  getEvent(nameOrSignatureOrTopic: "Unpaused"): EventFragment;
  getEvent(nameOrSignatureOrTopic: "Withdrawn"): EventFragment;
}

export type OwnershipTransferredEvent = TypedEvent<
  [string, string] & { previousOwner: string; newOwner: string }
>;

export type PausedEvent = TypedEvent<[string] & { account: string }>;

export type RewardAddedEvent = TypedEvent<[BigNumber] & { reward: BigNumber }>;

export type RewardPaidEvent = TypedEvent<
  [string, BigNumber, BigNumber] & {
    user: string;
    id: BigNumber;
    reward: BigNumber;
  }
>;

export type RewardsDurationUpdatedEvent = TypedEvent<
  [BigNumber] & { newDuration: BigNumber }
>;

export type StakedEvent = TypedEvent<
  [string, BigNumber, BigNumber] & {
    user: string;
    id: BigNumber;
    amount: BigNumber;
  }
>;

export type UnpausedEvent = TypedEvent<[string] & { account: string }>;

export type WithdrawnEvent = TypedEvent<
  [string, BigNumber, BigNumber] & {
    user: string;
    id: BigNumber;
    amount: BigNumber;
  }
>;

export class Minting extends BaseContract {
  connect(signerOrProvider: Signer | Provider | string): this;
  attach(addressOrName: string): this;
  deployed(): Promise<this>;

  listeners<EventArgsArray extends Array<any>, EventArgsObject>(
    eventFilter?: TypedEventFilter<EventArgsArray, EventArgsObject>
  ): Array<TypedListener<EventArgsArray, EventArgsObject>>;
  off<EventArgsArray extends Array<any>, EventArgsObject>(
    eventFilter: TypedEventFilter<EventArgsArray, EventArgsObject>,
    listener: TypedListener<EventArgsArray, EventArgsObject>
  ): this;
  on<EventArgsArray extends Array<any>, EventArgsObject>(
    eventFilter: TypedEventFilter<EventArgsArray, EventArgsObject>,
    listener: TypedListener<EventArgsArray, EventArgsObject>
  ): this;
  once<EventArgsArray extends Array<any>, EventArgsObject>(
    eventFilter: TypedEventFilter<EventArgsArray, EventArgsObject>,
    listener: TypedListener<EventArgsArray, EventArgsObject>
  ): this;
  removeListener<EventArgsArray extends Array<any>, EventArgsObject>(
    eventFilter: TypedEventFilter<EventArgsArray, EventArgsObject>,
    listener: TypedListener<EventArgsArray, EventArgsObject>
  ): this;
  removeAllListeners<EventArgsArray extends Array<any>, EventArgsObject>(
    eventFilter: TypedEventFilter<EventArgsArray, EventArgsObject>
  ): this;

  listeners(eventName?: string): Array<Listener>;
  off(eventName: string, listener: Listener): this;
  on(eventName: string, listener: Listener): this;
  once(eventName: string, listener: Listener): this;
  removeListener(eventName: string, listener: Listener): this;
  removeAllListeners(eventName?: string): this;

  queryFilter<EventArgsArray extends Array<any>, EventArgsObject>(
    event: TypedEventFilter<EventArgsArray, EventArgsObject>,
    fromBlockOrBlockhash?: string | number | undefined,
    toBlock?: string | number | undefined
  ): Promise<Array<TypedEvent<EventArgsArray & EventArgsObject>>>;

  interface: MintingInterface;

  functions: {
    APR_10(overrides?: CallOverrides): Promise<[BigNumber]>;

    APR_12_5(overrides?: CallOverrides): Promise<[BigNumber]>;

    APR_15(overrides?: CallOverrides): Promise<[BigNumber]>;

    APR_5(overrides?: CallOverrides): Promise<[BigNumber]>;

    APR_7_5(overrides?: CallOverrides): Promise<[BigNumber]>;

    DENOMINATOR(overrides?: CallOverrides): Promise<[BigNumber]>;

    MAX_STAKE_AMOUNT(overrides?: CallOverrides): Promise<[BigNumber]>;

    MAX_STAKE_PERIOD(overrides?: CallOverrides): Promise<[BigNumber]>;

    MIN_REWARDS_DURATION(overrides?: CallOverrides): Promise<[BigNumber]>;

    MIN_STAKE_AMOUNT(overrides?: CallOverrides): Promise<[BigNumber]>;

    MIN_STAKE_PERIOD(overrides?: CallOverrides): Promise<[BigNumber]>;

    YEAR(overrides?: CallOverrides): Promise<[BigNumber]>;

    balanceOf(account: string, overrides?: CallOverrides): Promise<[BigNumber]>;

    emergencyWithdrawRewards(
      rewardA: BigNumberish,
      rewardB: BigNumberish,
      recepient: string,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<ContractTransaction>;

    factory(overrides?: CallOverrides): Promise<[string]>;

    getAPRForDuration(
      duration: BigNumberish,
      overrides?: CallOverrides
    ): Promise<[BigNumber] & { apr: BigNumber }>;

    getHoldersLength(overrides?: CallOverrides): Promise<[BigNumber]>;

    getHoldersSlice(
      startIndex: BigNumberish,
      length: BigNumberish,
      overrides?: CallOverrides
    ): Promise<[string[]]>;

    getRewardsAvailable(
      overrides?: CallOverrides
    ): Promise<
      [BigNumber, BigNumber] & { rewardA: BigNumber; rewardB: BigNumber }
    >;

    getStakeMaxReserves(
      id: BigNumberish,
      overrides?: CallOverrides
    ): Promise<
      [BigNumber, BigNumber] & {
        maxReserveA: BigNumber;
        maxReserveB: BigNumber;
      }
    >;

    getUserInactiveStakesLength(
      user: string,
      overrides?: CallOverrides
    ): Promise<[BigNumber]>;

    getUserInactiveStakesSlice(
      user: string,
      startIndex: BigNumberish,
      length: BigNumberish,
      overrides?: CallOverrides
    ): Promise<
      [
        ([
          string,
          BigNumber,
          [BigNumber, BigNumber] & { reserveA: BigNumber; reserveB: BigNumber },
          BigNumber,
          BigNumber,
          BigNumber
        ] & {
          owner: string;
          amount: BigNumber;
          reserves: [BigNumber, BigNumber] & {
            reserveA: BigNumber;
            reserveB: BigNumber;
          };
          duration: BigNumber;
          timestamp: BigNumber;
          unstakedAtBlockTimestamp: BigNumber;
        })[]
      ]
    >;

    getUserStakeIds(
      user: string,
      overrides?: CallOverrides
    ): Promise<[BigNumber[]]>;

    getUserStakeIdsLength(
      user: string,
      overrides?: CallOverrides
    ): Promise<[BigNumber]>;

    getUserStakesIdsSlice(
      user: string,
      startIndex: BigNumberish,
      length: BigNumberish,
      overrides?: CallOverrides
    ): Promise<
      [
        ([
          string,
          BigNumber,
          [BigNumber, BigNumber] & { reserveA: BigNumber; reserveB: BigNumber },
          BigNumber,
          BigNumber,
          BigNumber
        ] & {
          owner: string;
          amount: BigNumber;
          reserves: [BigNumber, BigNumber] & {
            reserveA: BigNumber;
            reserveB: BigNumber;
          };
          duration: BigNumber;
          timestamp: BigNumber;
          unstakedAtBlockTimestamp: BigNumber;
        })[]
      ]
    >;

    globalId(overrides?: CallOverrides): Promise<[BigNumber]>;

    initialize(
      router_: string,
      tokenA_: string,
      tokenB_: string,
      tokenAFactor_: BigNumberish,
      tokenBFactor_: BigNumberish,
      owner_: string,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<ContractTransaction>;

    initialized(overrides?: CallOverrides): Promise<[boolean]>;

    maxPotentialDebtA(overrides?: CallOverrides): Promise<[BigNumber]>;

    maxPotentialDebtB(overrides?: CallOverrides): Promise<[BigNumber]>;

    numOfActiveStakes(overrides?: CallOverrides): Promise<[BigNumber]>;

    owner(overrides?: CallOverrides): Promise<[string]>;

    pair(overrides?: CallOverrides): Promise<[string]>;

    paused(overrides?: CallOverrides): Promise<[boolean]>;

    renounceOwnership(
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<ContractTransaction>;

    rewardTokenA(overrides?: CallOverrides): Promise<[string]>;

    rewardTokenB(overrides?: CallOverrides): Promise<[string]>;

    router(overrides?: CallOverrides): Promise<[string]>;

    setPaused(
      paused: boolean,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<ContractTransaction>;

    stake(
      amount: BigNumberish,
      stakingPeriod: BigNumberish,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<ContractTransaction>;

    stakes(
      arg0: BigNumberish,
      overrides?: CallOverrides
    ): Promise<
      [
        string,
        BigNumber,
        [BigNumber, BigNumber] & { reserveA: BigNumber; reserveB: BigNumber },
        BigNumber,
        BigNumber,
        BigNumber
      ] & {
        owner: string;
        amount: BigNumber;
        reserves: [BigNumber, BigNumber] & {
          reserveA: BigNumber;
          reserveB: BigNumber;
        };
        duration: BigNumber;
        timestamp: BigNumber;
        unstakedAtBlockTimestamp: BigNumber;
      }
    >;

    tokenAFactor(overrides?: CallOverrides): Promise<[BigNumber]>;

    tokenBFactor(overrides?: CallOverrides): Promise<[BigNumber]>;

    transferOwnership(
      newOwner: string,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<ContractTransaction>;

    userBalances(arg0: string, overrides?: CallOverrides): Promise<[BigNumber]>;

    userInactiveStakes(
      arg0: string,
      arg1: BigNumberish,
      overrides?: CallOverrides
    ): Promise<[BigNumber]>;

    withdraw(
      id: BigNumberish,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<ContractTransaction>;
  };

  APR_10(overrides?: CallOverrides): Promise<BigNumber>;

  APR_12_5(overrides?: CallOverrides): Promise<BigNumber>;

  APR_15(overrides?: CallOverrides): Promise<BigNumber>;

  APR_5(overrides?: CallOverrides): Promise<BigNumber>;

  APR_7_5(overrides?: CallOverrides): Promise<BigNumber>;

  DENOMINATOR(overrides?: CallOverrides): Promise<BigNumber>;

  MAX_STAKE_AMOUNT(overrides?: CallOverrides): Promise<BigNumber>;

  MAX_STAKE_PERIOD(overrides?: CallOverrides): Promise<BigNumber>;

  MIN_REWARDS_DURATION(overrides?: CallOverrides): Promise<BigNumber>;

  MIN_STAKE_AMOUNT(overrides?: CallOverrides): Promise<BigNumber>;

  MIN_STAKE_PERIOD(overrides?: CallOverrides): Promise<BigNumber>;

  YEAR(overrides?: CallOverrides): Promise<BigNumber>;

  balanceOf(account: string, overrides?: CallOverrides): Promise<BigNumber>;

  emergencyWithdrawRewards(
    rewardA: BigNumberish,
    rewardB: BigNumberish,
    recepient: string,
    overrides?: Overrides & { from?: string | Promise<string> }
  ): Promise<ContractTransaction>;

  factory(overrides?: CallOverrides): Promise<string>;

  getAPRForDuration(
    duration: BigNumberish,
    overrides?: CallOverrides
  ): Promise<BigNumber>;

  getHoldersLength(overrides?: CallOverrides): Promise<BigNumber>;

  getHoldersSlice(
    startIndex: BigNumberish,
    length: BigNumberish,
    overrides?: CallOverrides
  ): Promise<string[]>;

  getRewardsAvailable(
    overrides?: CallOverrides
  ): Promise<
    [BigNumber, BigNumber] & { rewardA: BigNumber; rewardB: BigNumber }
  >;

  getStakeMaxReserves(
    id: BigNumberish,
    overrides?: CallOverrides
  ): Promise<
    [BigNumber, BigNumber] & { maxReserveA: BigNumber; maxReserveB: BigNumber }
  >;

  getUserInactiveStakesLength(
    user: string,
    overrides?: CallOverrides
  ): Promise<BigNumber>;

  getUserInactiveStakesSlice(
    user: string,
    startIndex: BigNumberish,
    length: BigNumberish,
    overrides?: CallOverrides
  ): Promise<
    ([
      string,
      BigNumber,
      [BigNumber, BigNumber] & { reserveA: BigNumber; reserveB: BigNumber },
      BigNumber,
      BigNumber,
      BigNumber
    ] & {
      owner: string;
      amount: BigNumber;
      reserves: [BigNumber, BigNumber] & {
        reserveA: BigNumber;
        reserveB: BigNumber;
      };
      duration: BigNumber;
      timestamp: BigNumber;
      unstakedAtBlockTimestamp: BigNumber;
    })[]
  >;

  getUserStakeIds(
    user: string,
    overrides?: CallOverrides
  ): Promise<BigNumber[]>;

  getUserStakeIdsLength(
    user: string,
    overrides?: CallOverrides
  ): Promise<BigNumber>;

  getUserStakesIdsSlice(
    user: string,
    startIndex: BigNumberish,
    length: BigNumberish,
    overrides?: CallOverrides
  ): Promise<
    ([
      string,
      BigNumber,
      [BigNumber, BigNumber] & { reserveA: BigNumber; reserveB: BigNumber },
      BigNumber,
      BigNumber,
      BigNumber
    ] & {
      owner: string;
      amount: BigNumber;
      reserves: [BigNumber, BigNumber] & {
        reserveA: BigNumber;
        reserveB: BigNumber;
      };
      duration: BigNumber;
      timestamp: BigNumber;
      unstakedAtBlockTimestamp: BigNumber;
    })[]
  >;

  globalId(overrides?: CallOverrides): Promise<BigNumber>;

  initialize(
    router_: string,
    tokenA_: string,
    tokenB_: string,
    tokenAFactor_: BigNumberish,
    tokenBFactor_: BigNumberish,
    owner_: string,
    overrides?: Overrides & { from?: string | Promise<string> }
  ): Promise<ContractTransaction>;

  initialized(overrides?: CallOverrides): Promise<boolean>;

  maxPotentialDebtA(overrides?: CallOverrides): Promise<BigNumber>;

  maxPotentialDebtB(overrides?: CallOverrides): Promise<BigNumber>;

  numOfActiveStakes(overrides?: CallOverrides): Promise<BigNumber>;

  owner(overrides?: CallOverrides): Promise<string>;

  pair(overrides?: CallOverrides): Promise<string>;

  paused(overrides?: CallOverrides): Promise<boolean>;

  renounceOwnership(
    overrides?: Overrides & { from?: string | Promise<string> }
  ): Promise<ContractTransaction>;

  rewardTokenA(overrides?: CallOverrides): Promise<string>;

  rewardTokenB(overrides?: CallOverrides): Promise<string>;

  router(overrides?: CallOverrides): Promise<string>;

  setPaused(
    paused: boolean,
    overrides?: Overrides & { from?: string | Promise<string> }
  ): Promise<ContractTransaction>;

  stake(
    amount: BigNumberish,
    stakingPeriod: BigNumberish,
    overrides?: Overrides & { from?: string | Promise<string> }
  ): Promise<ContractTransaction>;

  stakes(
    arg0: BigNumberish,
    overrides?: CallOverrides
  ): Promise<
    [
      string,
      BigNumber,
      [BigNumber, BigNumber] & { reserveA: BigNumber; reserveB: BigNumber },
      BigNumber,
      BigNumber,
      BigNumber
    ] & {
      owner: string;
      amount: BigNumber;
      reserves: [BigNumber, BigNumber] & {
        reserveA: BigNumber;
        reserveB: BigNumber;
      };
      duration: BigNumber;
      timestamp: BigNumber;
      unstakedAtBlockTimestamp: BigNumber;
    }
  >;

  tokenAFactor(overrides?: CallOverrides): Promise<BigNumber>;

  tokenBFactor(overrides?: CallOverrides): Promise<BigNumber>;

  transferOwnership(
    newOwner: string,
    overrides?: Overrides & { from?: string | Promise<string> }
  ): Promise<ContractTransaction>;

  userBalances(arg0: string, overrides?: CallOverrides): Promise<BigNumber>;

  userInactiveStakes(
    arg0: string,
    arg1: BigNumberish,
    overrides?: CallOverrides
  ): Promise<BigNumber>;

  withdraw(
    id: BigNumberish,
    overrides?: Overrides & { from?: string | Promise<string> }
  ): Promise<ContractTransaction>;

  callStatic: {
    APR_10(overrides?: CallOverrides): Promise<BigNumber>;

    APR_12_5(overrides?: CallOverrides): Promise<BigNumber>;

    APR_15(overrides?: CallOverrides): Promise<BigNumber>;

    APR_5(overrides?: CallOverrides): Promise<BigNumber>;

    APR_7_5(overrides?: CallOverrides): Promise<BigNumber>;

    DENOMINATOR(overrides?: CallOverrides): Promise<BigNumber>;

    MAX_STAKE_AMOUNT(overrides?: CallOverrides): Promise<BigNumber>;

    MAX_STAKE_PERIOD(overrides?: CallOverrides): Promise<BigNumber>;

    MIN_REWARDS_DURATION(overrides?: CallOverrides): Promise<BigNumber>;

    MIN_STAKE_AMOUNT(overrides?: CallOverrides): Promise<BigNumber>;

    MIN_STAKE_PERIOD(overrides?: CallOverrides): Promise<BigNumber>;

    YEAR(overrides?: CallOverrides): Promise<BigNumber>;

    balanceOf(account: string, overrides?: CallOverrides): Promise<BigNumber>;

    emergencyWithdrawRewards(
      rewardA: BigNumberish,
      rewardB: BigNumberish,
      recepient: string,
      overrides?: CallOverrides
    ): Promise<void>;

    factory(overrides?: CallOverrides): Promise<string>;

    getAPRForDuration(
      duration: BigNumberish,
      overrides?: CallOverrides
    ): Promise<BigNumber>;

    getHoldersLength(overrides?: CallOverrides): Promise<BigNumber>;

    getHoldersSlice(
      startIndex: BigNumberish,
      length: BigNumberish,
      overrides?: CallOverrides
    ): Promise<string[]>;

    getRewardsAvailable(
      overrides?: CallOverrides
    ): Promise<
      [BigNumber, BigNumber] & { rewardA: BigNumber; rewardB: BigNumber }
    >;

    getStakeMaxReserves(
      id: BigNumberish,
      overrides?: CallOverrides
    ): Promise<
      [BigNumber, BigNumber] & {
        maxReserveA: BigNumber;
        maxReserveB: BigNumber;
      }
    >;

    getUserInactiveStakesLength(
      user: string,
      overrides?: CallOverrides
    ): Promise<BigNumber>;

    getUserInactiveStakesSlice(
      user: string,
      startIndex: BigNumberish,
      length: BigNumberish,
      overrides?: CallOverrides
    ): Promise<
      ([
        string,
        BigNumber,
        [BigNumber, BigNumber] & { reserveA: BigNumber; reserveB: BigNumber },
        BigNumber,
        BigNumber,
        BigNumber
      ] & {
        owner: string;
        amount: BigNumber;
        reserves: [BigNumber, BigNumber] & {
          reserveA: BigNumber;
          reserveB: BigNumber;
        };
        duration: BigNumber;
        timestamp: BigNumber;
        unstakedAtBlockTimestamp: BigNumber;
      })[]
    >;

    getUserStakeIds(
      user: string,
      overrides?: CallOverrides
    ): Promise<BigNumber[]>;

    getUserStakeIdsLength(
      user: string,
      overrides?: CallOverrides
    ): Promise<BigNumber>;

    getUserStakesIdsSlice(
      user: string,
      startIndex: BigNumberish,
      length: BigNumberish,
      overrides?: CallOverrides
    ): Promise<
      ([
        string,
        BigNumber,
        [BigNumber, BigNumber] & { reserveA: BigNumber; reserveB: BigNumber },
        BigNumber,
        BigNumber,
        BigNumber
      ] & {
        owner: string;
        amount: BigNumber;
        reserves: [BigNumber, BigNumber] & {
          reserveA: BigNumber;
          reserveB: BigNumber;
        };
        duration: BigNumber;
        timestamp: BigNumber;
        unstakedAtBlockTimestamp: BigNumber;
      })[]
    >;

    globalId(overrides?: CallOverrides): Promise<BigNumber>;

    initialize(
      router_: string,
      tokenA_: string,
      tokenB_: string,
      tokenAFactor_: BigNumberish,
      tokenBFactor_: BigNumberish,
      owner_: string,
      overrides?: CallOverrides
    ): Promise<void>;

    initialized(overrides?: CallOverrides): Promise<boolean>;

    maxPotentialDebtA(overrides?: CallOverrides): Promise<BigNumber>;

    maxPotentialDebtB(overrides?: CallOverrides): Promise<BigNumber>;

    numOfActiveStakes(overrides?: CallOverrides): Promise<BigNumber>;

    owner(overrides?: CallOverrides): Promise<string>;

    pair(overrides?: CallOverrides): Promise<string>;

    paused(overrides?: CallOverrides): Promise<boolean>;

    renounceOwnership(overrides?: CallOverrides): Promise<void>;

    rewardTokenA(overrides?: CallOverrides): Promise<string>;

    rewardTokenB(overrides?: CallOverrides): Promise<string>;

    router(overrides?: CallOverrides): Promise<string>;

    setPaused(paused: boolean, overrides?: CallOverrides): Promise<void>;

    stake(
      amount: BigNumberish,
      stakingPeriod: BigNumberish,
      overrides?: CallOverrides
    ): Promise<void>;

    stakes(
      arg0: BigNumberish,
      overrides?: CallOverrides
    ): Promise<
      [
        string,
        BigNumber,
        [BigNumber, BigNumber] & { reserveA: BigNumber; reserveB: BigNumber },
        BigNumber,
        BigNumber,
        BigNumber
      ] & {
        owner: string;
        amount: BigNumber;
        reserves: [BigNumber, BigNumber] & {
          reserveA: BigNumber;
          reserveB: BigNumber;
        };
        duration: BigNumber;
        timestamp: BigNumber;
        unstakedAtBlockTimestamp: BigNumber;
      }
    >;

    tokenAFactor(overrides?: CallOverrides): Promise<BigNumber>;

    tokenBFactor(overrides?: CallOverrides): Promise<BigNumber>;

    transferOwnership(
      newOwner: string,
      overrides?: CallOverrides
    ): Promise<void>;

    userBalances(arg0: string, overrides?: CallOverrides): Promise<BigNumber>;

    userInactiveStakes(
      arg0: string,
      arg1: BigNumberish,
      overrides?: CallOverrides
    ): Promise<BigNumber>;

    withdraw(id: BigNumberish, overrides?: CallOverrides): Promise<void>;
  };

  filters: {
    "OwnershipTransferred(address,address)"(
      previousOwner?: string | null,
      newOwner?: string | null
    ): TypedEventFilter<
      [string, string],
      { previousOwner: string; newOwner: string }
    >;

    OwnershipTransferred(
      previousOwner?: string | null,
      newOwner?: string | null
    ): TypedEventFilter<
      [string, string],
      { previousOwner: string; newOwner: string }
    >;

    "Paused(address)"(
      account?: null
    ): TypedEventFilter<[string], { account: string }>;

    Paused(account?: null): TypedEventFilter<[string], { account: string }>;

    "RewardAdded(uint256)"(
      reward?: null
    ): TypedEventFilter<[BigNumber], { reward: BigNumber }>;

    RewardAdded(
      reward?: null
    ): TypedEventFilter<[BigNumber], { reward: BigNumber }>;

    "RewardPaid(address,uint256,uint256)"(
      user?: null,
      id?: BigNumberish | null,
      reward?: null
    ): TypedEventFilter<
      [string, BigNumber, BigNumber],
      { user: string; id: BigNumber; reward: BigNumber }
    >;

    RewardPaid(
      user?: null,
      id?: BigNumberish | null,
      reward?: null
    ): TypedEventFilter<
      [string, BigNumber, BigNumber],
      { user: string; id: BigNumber; reward: BigNumber }
    >;

    "RewardsDurationUpdated(uint256)"(
      newDuration?: null
    ): TypedEventFilter<[BigNumber], { newDuration: BigNumber }>;

    RewardsDurationUpdated(
      newDuration?: null
    ): TypedEventFilter<[BigNumber], { newDuration: BigNumber }>;

    "Staked(address,uint256,uint256)"(
      user?: string | null,
      id?: BigNumberish | null,
      amount?: null
    ): TypedEventFilter<
      [string, BigNumber, BigNumber],
      { user: string; id: BigNumber; amount: BigNumber }
    >;

    Staked(
      user?: string | null,
      id?: BigNumberish | null,
      amount?: null
    ): TypedEventFilter<
      [string, BigNumber, BigNumber],
      { user: string; id: BigNumber; amount: BigNumber }
    >;

    "Unpaused(address)"(
      account?: null
    ): TypedEventFilter<[string], { account: string }>;

    Unpaused(account?: null): TypedEventFilter<[string], { account: string }>;

    "Withdrawn(address,uint256,uint256)"(
      user?: null,
      id?: BigNumberish | null,
      amount?: null
    ): TypedEventFilter<
      [string, BigNumber, BigNumber],
      { user: string; id: BigNumber; amount: BigNumber }
    >;

    Withdrawn(
      user?: null,
      id?: BigNumberish | null,
      amount?: null
    ): TypedEventFilter<
      [string, BigNumber, BigNumber],
      { user: string; id: BigNumber; amount: BigNumber }
    >;
  };

  estimateGas: {
    APR_10(overrides?: CallOverrides): Promise<BigNumber>;

    APR_12_5(overrides?: CallOverrides): Promise<BigNumber>;

    APR_15(overrides?: CallOverrides): Promise<BigNumber>;

    APR_5(overrides?: CallOverrides): Promise<BigNumber>;

    APR_7_5(overrides?: CallOverrides): Promise<BigNumber>;

    DENOMINATOR(overrides?: CallOverrides): Promise<BigNumber>;

    MAX_STAKE_AMOUNT(overrides?: CallOverrides): Promise<BigNumber>;

    MAX_STAKE_PERIOD(overrides?: CallOverrides): Promise<BigNumber>;

    MIN_REWARDS_DURATION(overrides?: CallOverrides): Promise<BigNumber>;

    MIN_STAKE_AMOUNT(overrides?: CallOverrides): Promise<BigNumber>;

    MIN_STAKE_PERIOD(overrides?: CallOverrides): Promise<BigNumber>;

    YEAR(overrides?: CallOverrides): Promise<BigNumber>;

    balanceOf(account: string, overrides?: CallOverrides): Promise<BigNumber>;

    emergencyWithdrawRewards(
      rewardA: BigNumberish,
      rewardB: BigNumberish,
      recepient: string,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<BigNumber>;

    factory(overrides?: CallOverrides): Promise<BigNumber>;

    getAPRForDuration(
      duration: BigNumberish,
      overrides?: CallOverrides
    ): Promise<BigNumber>;

    getHoldersLength(overrides?: CallOverrides): Promise<BigNumber>;

    getHoldersSlice(
      startIndex: BigNumberish,
      length: BigNumberish,
      overrides?: CallOverrides
    ): Promise<BigNumber>;

    getRewardsAvailable(overrides?: CallOverrides): Promise<BigNumber>;

    getStakeMaxReserves(
      id: BigNumberish,
      overrides?: CallOverrides
    ): Promise<BigNumber>;

    getUserInactiveStakesLength(
      user: string,
      overrides?: CallOverrides
    ): Promise<BigNumber>;

    getUserInactiveStakesSlice(
      user: string,
      startIndex: BigNumberish,
      length: BigNumberish,
      overrides?: CallOverrides
    ): Promise<BigNumber>;

    getUserStakeIds(
      user: string,
      overrides?: CallOverrides
    ): Promise<BigNumber>;

    getUserStakeIdsLength(
      user: string,
      overrides?: CallOverrides
    ): Promise<BigNumber>;

    getUserStakesIdsSlice(
      user: string,
      startIndex: BigNumberish,
      length: BigNumberish,
      overrides?: CallOverrides
    ): Promise<BigNumber>;

    globalId(overrides?: CallOverrides): Promise<BigNumber>;

    initialize(
      router_: string,
      tokenA_: string,
      tokenB_: string,
      tokenAFactor_: BigNumberish,
      tokenBFactor_: BigNumberish,
      owner_: string,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<BigNumber>;

    initialized(overrides?: CallOverrides): Promise<BigNumber>;

    maxPotentialDebtA(overrides?: CallOverrides): Promise<BigNumber>;

    maxPotentialDebtB(overrides?: CallOverrides): Promise<BigNumber>;

    numOfActiveStakes(overrides?: CallOverrides): Promise<BigNumber>;

    owner(overrides?: CallOverrides): Promise<BigNumber>;

    pair(overrides?: CallOverrides): Promise<BigNumber>;

    paused(overrides?: CallOverrides): Promise<BigNumber>;

    renounceOwnership(
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<BigNumber>;

    rewardTokenA(overrides?: CallOverrides): Promise<BigNumber>;

    rewardTokenB(overrides?: CallOverrides): Promise<BigNumber>;

    router(overrides?: CallOverrides): Promise<BigNumber>;

    setPaused(
      paused: boolean,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<BigNumber>;

    stake(
      amount: BigNumberish,
      stakingPeriod: BigNumberish,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<BigNumber>;

    stakes(arg0: BigNumberish, overrides?: CallOverrides): Promise<BigNumber>;

    tokenAFactor(overrides?: CallOverrides): Promise<BigNumber>;

    tokenBFactor(overrides?: CallOverrides): Promise<BigNumber>;

    transferOwnership(
      newOwner: string,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<BigNumber>;

    userBalances(arg0: string, overrides?: CallOverrides): Promise<BigNumber>;

    userInactiveStakes(
      arg0: string,
      arg1: BigNumberish,
      overrides?: CallOverrides
    ): Promise<BigNumber>;

    withdraw(
      id: BigNumberish,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<BigNumber>;
  };

  populateTransaction: {
    APR_10(overrides?: CallOverrides): Promise<PopulatedTransaction>;

    APR_12_5(overrides?: CallOverrides): Promise<PopulatedTransaction>;

    APR_15(overrides?: CallOverrides): Promise<PopulatedTransaction>;

    APR_5(overrides?: CallOverrides): Promise<PopulatedTransaction>;

    APR_7_5(overrides?: CallOverrides): Promise<PopulatedTransaction>;

    DENOMINATOR(overrides?: CallOverrides): Promise<PopulatedTransaction>;

    MAX_STAKE_AMOUNT(overrides?: CallOverrides): Promise<PopulatedTransaction>;

    MAX_STAKE_PERIOD(overrides?: CallOverrides): Promise<PopulatedTransaction>;

    MIN_REWARDS_DURATION(
      overrides?: CallOverrides
    ): Promise<PopulatedTransaction>;

    MIN_STAKE_AMOUNT(overrides?: CallOverrides): Promise<PopulatedTransaction>;

    MIN_STAKE_PERIOD(overrides?: CallOverrides): Promise<PopulatedTransaction>;

    YEAR(overrides?: CallOverrides): Promise<PopulatedTransaction>;

    balanceOf(
      account: string,
      overrides?: CallOverrides
    ): Promise<PopulatedTransaction>;

    emergencyWithdrawRewards(
      rewardA: BigNumberish,
      rewardB: BigNumberish,
      recepient: string,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<PopulatedTransaction>;

    factory(overrides?: CallOverrides): Promise<PopulatedTransaction>;

    getAPRForDuration(
      duration: BigNumberish,
      overrides?: CallOverrides
    ): Promise<PopulatedTransaction>;

    getHoldersLength(overrides?: CallOverrides): Promise<PopulatedTransaction>;

    getHoldersSlice(
      startIndex: BigNumberish,
      length: BigNumberish,
      overrides?: CallOverrides
    ): Promise<PopulatedTransaction>;

    getRewardsAvailable(
      overrides?: CallOverrides
    ): Promise<PopulatedTransaction>;

    getStakeMaxReserves(
      id: BigNumberish,
      overrides?: CallOverrides
    ): Promise<PopulatedTransaction>;

    getUserInactiveStakesLength(
      user: string,
      overrides?: CallOverrides
    ): Promise<PopulatedTransaction>;

    getUserInactiveStakesSlice(
      user: string,
      startIndex: BigNumberish,
      length: BigNumberish,
      overrides?: CallOverrides
    ): Promise<PopulatedTransaction>;

    getUserStakeIds(
      user: string,
      overrides?: CallOverrides
    ): Promise<PopulatedTransaction>;

    getUserStakeIdsLength(
      user: string,
      overrides?: CallOverrides
    ): Promise<PopulatedTransaction>;

    getUserStakesIdsSlice(
      user: string,
      startIndex: BigNumberish,
      length: BigNumberish,
      overrides?: CallOverrides
    ): Promise<PopulatedTransaction>;

    globalId(overrides?: CallOverrides): Promise<PopulatedTransaction>;

    initialize(
      router_: string,
      tokenA_: string,
      tokenB_: string,
      tokenAFactor_: BigNumberish,
      tokenBFactor_: BigNumberish,
      owner_: string,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<PopulatedTransaction>;

    initialized(overrides?: CallOverrides): Promise<PopulatedTransaction>;

    maxPotentialDebtA(overrides?: CallOverrides): Promise<PopulatedTransaction>;

    maxPotentialDebtB(overrides?: CallOverrides): Promise<PopulatedTransaction>;

    numOfActiveStakes(overrides?: CallOverrides): Promise<PopulatedTransaction>;

    owner(overrides?: CallOverrides): Promise<PopulatedTransaction>;

    pair(overrides?: CallOverrides): Promise<PopulatedTransaction>;

    paused(overrides?: CallOverrides): Promise<PopulatedTransaction>;

    renounceOwnership(
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<PopulatedTransaction>;

    rewardTokenA(overrides?: CallOverrides): Promise<PopulatedTransaction>;

    rewardTokenB(overrides?: CallOverrides): Promise<PopulatedTransaction>;

    router(overrides?: CallOverrides): Promise<PopulatedTransaction>;

    setPaused(
      paused: boolean,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<PopulatedTransaction>;

    stake(
      amount: BigNumberish,
      stakingPeriod: BigNumberish,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<PopulatedTransaction>;

    stakes(
      arg0: BigNumberish,
      overrides?: CallOverrides
    ): Promise<PopulatedTransaction>;

    tokenAFactor(overrides?: CallOverrides): Promise<PopulatedTransaction>;

    tokenBFactor(overrides?: CallOverrides): Promise<PopulatedTransaction>;

    transferOwnership(
      newOwner: string,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<PopulatedTransaction>;

    userBalances(
      arg0: string,
      overrides?: CallOverrides
    ): Promise<PopulatedTransaction>;

    userInactiveStakes(
      arg0: string,
      arg1: BigNumberish,
      overrides?: CallOverrides
    ): Promise<PopulatedTransaction>;

    withdraw(
      id: BigNumberish,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<PopulatedTransaction>;
  };
}
